(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/common/http'), require('@angular/platform-browser'), require('marked'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-markdown', ['exports', '@angular/core', '@angular/common', '@angular/common/http', '@angular/platform-browser', 'marked', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['ngx-markdown'] = {}, global.ng.core, global.ng.common, global.ng.common.http, global.ng.platformBrowser, global.marked, global.rxjs.operators));
}(this, function (exports, core, common, http, platformBrowser, marked, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LanguagePipe = /** @class */ (function () {
        function LanguagePipe() {
        }
        /**
         * @param {?} value
         * @param {?} language
         * @return {?}
         */
        LanguagePipe.prototype.transform = /**
         * @param {?} value
         * @param {?} language
         * @return {?}
         */
        function (value, language) {
            if (typeof value !== 'string') {
                console.error("LanguagePipe has been invoked with an invalid value type [" + value + "]");
                return value;
            }
            if (typeof language !== 'string') {
                console.error("LanguagePipe has been invoked with an invalid parameter [" + language + "]");
                return value;
            }
            return '```' + language + '\n' + value + '\n```';
        };
        LanguagePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'language',
                    },] }
        ];
        return LanguagePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkedOptions = /** @class */ (function () {
        function MarkedOptions() {
        }
        return MarkedOptions;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkedRenderer = /** @class */ (function (_super) {
        __extends(MarkedRenderer, _super);
        function MarkedRenderer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MarkedRenderer;
    }(marked.Renderer));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // tslint:disable-next-line:max-line-length
    /** @type {?} */
    var errorSrcWithoutHttpClient = '[ngx-markdown] When using the [src] attribute you *have to* pass the `HttpClient` as a parameter of the `forRoot` method. See README for more information';
    var MarkdownService = /** @class */ (function () {
        function MarkdownService(platform, http, domSanitizer, options) {
            this.platform = platform;
            this.http = http;
            this.domSanitizer = domSanitizer;
            this.options = options;
        }
        Object.defineProperty(MarkdownService.prototype, "options", {
            get: /**
             * @return {?}
             */
            function () { return this._options; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._options = Object.assign({}, { renderer: new MarkedRenderer() }, this._options, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MarkdownService.prototype, "renderer", {
            get: /**
             * @return {?}
             */
            function () { return this.options.renderer; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.options.renderer = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} markdown
         * @param {?=} decodeHtml
         * @param {?=} markedOptions
         * @return {?}
         */
        MarkdownService.prototype.compile = /**
         * @param {?} markdown
         * @param {?=} decodeHtml
         * @param {?=} markedOptions
         * @return {?}
         */
        function (markdown, decodeHtml, markedOptions) {
            if (decodeHtml === void 0) { decodeHtml = false; }
            if (markedOptions === void 0) { markedOptions = this.options; }
            /** @type {?} */
            var precompiled = this.precompile(markdown);
            /** @type {?} */
            var compiled = marked.parse(decodeHtml ? this.decodeHtml(precompiled) : precompiled, markedOptions);
            return markedOptions.sanitize && !markedOptions.sanitizer
                ? this.domSanitizer.sanitize(core.SecurityContext.HTML, compiled)
                : compiled;
        };
        /**
         * @param {?} src
         * @return {?}
         */
        MarkdownService.prototype.getSource = /**
         * @param {?} src
         * @return {?}
         */
        function (src) {
            var _this = this;
            if (!this.http) {
                throw new Error(errorSrcWithoutHttpClient);
            }
            return this.http
                .get(src, { responseType: 'text' })
                .pipe(operators.map((/**
             * @param {?} markdown
             * @return {?}
             */
            function (markdown) { return _this.handleExtension(src, markdown); })));
        };
        /**
         * @param {?=} element
         * @return {?}
         */
        MarkdownService.prototype.highlight = /**
         * @param {?=} element
         * @return {?}
         */
        function (element) {
            if (common.isPlatformBrowser(this.platform) && typeof Prism !== 'undefined') {
                if (!element) {
                    element = document;
                }
                element
                    .querySelectorAll('pre code:not([class*="language-"])')
                    .forEach((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) { return x.classList.add('language-none'); }));
                Prism.highlightAllUnder(element);
            }
        };
        /**
         * @private
         * @param {?} html
         * @return {?}
         */
        MarkdownService.prototype.decodeHtml = /**
         * @private
         * @param {?} html
         * @return {?}
         */
        function (html) {
            if (common.isPlatformBrowser(this.platform)) {
                /** @type {?} */
                var textarea = document.createElement('textarea');
                textarea.innerHTML = html;
                return textarea.value;
            }
            return html;
        };
        /**
         * @private
         * @param {?} src
         * @param {?} markdown
         * @return {?}
         */
        MarkdownService.prototype.handleExtension = /**
         * @private
         * @param {?} src
         * @param {?} markdown
         * @return {?}
         */
        function (src, markdown) {
            /** @type {?} */
            var extension = src
                ? src.split('?')[0].split('.').splice(-1).join()
                : null;
            return extension !== 'md'
                ? '```' + extension + '\n' + markdown + '\n```'
                : markdown;
        };
        /**
         * @private
         * @param {?} markdown
         * @return {?}
         */
        MarkdownService.prototype.precompile = /**
         * @private
         * @param {?} markdown
         * @return {?}
         */
        function (markdown) {
            if (!markdown) {
                return '';
            }
            /** @type {?} */
            var indentStart;
            return markdown
                .split('\n')
                .map((/**
             * @param {?} line
             * @return {?}
             */
            function (line) {
                // set current line ident start to base reference indentation
                /** @type {?} */
                var lineIdentStart = indentStart;
                // find position of 1st non-whitespace character
                // to determine the current line indentation start
                if (line.length > 0) {
                    lineIdentStart = isNaN(lineIdentStart)
                        ? line.search(/\S|$/)
                        : Math.min(line.search(/\S|$/), lineIdentStart);
                }
                // keep 1st non-whitespace line indentation
                // as base reference for other lines
                if (isNaN(indentStart)) {
                    indentStart = lineIdentStart;
                }
                // remove whitespaces before current line indentation
                return !!lineIdentStart
                    ? line.substring(lineIdentStart)
                    : line;
            })).join('\n');
        };
        MarkdownService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        MarkdownService.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: http.HttpClient, decorators: [{ type: core.Optional }] },
            { type: platformBrowser.DomSanitizer },
            { type: MarkedOptions }
        ]; };
        return MarkdownService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PrismPlugin = {
        LineHighlight: 'line-highlight',
        LineNumbers: 'line-numbers',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkdownComponent = /** @class */ (function () {
        function MarkdownComponent(element, markdownService) {
            this.element = element;
            this.markdownService = markdownService;
            this.error = new core.EventEmitter();
            this.load = new core.EventEmitter();
            this._lineHighlight = false;
            this._lineNumbers = false;
        }
        Object.defineProperty(MarkdownComponent.prototype, "lineNumbers", {
            // Plugin - lineNumbers
            get: 
            // Plugin - lineNumbers
            /**
             * @return {?}
             */
            function () { return this._lineNumbers; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._lineNumbers = this.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MarkdownComponent.prototype, "lineHighlight", {
            // Plugin - lineHighlight
            get: 
            // Plugin - lineHighlight
            /**
             * @return {?}
             */
            function () { return this._lineHighlight; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._lineHighlight = this.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MarkdownComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (this.data) {
                this.handleData();
                return;
            }
            if (this.src) {
                this.handleSrc();
                return;
            }
        };
        /**
         * @return {?}
         */
        MarkdownComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            if (!this.data && !this.src) {
                this.handleTransclusion();
            }
        };
        /**
         * @param {?} markdown
         * @param {?=} decodeHtml
         * @return {?}
         */
        MarkdownComponent.prototype.render = /**
         * @param {?} markdown
         * @param {?=} decodeHtml
         * @return {?}
         */
        function (markdown, decodeHtml) {
            if (decodeHtml === void 0) { decodeHtml = false; }
            this.element.nativeElement.innerHTML = this.markdownService.compile(markdown, decodeHtml);
            this.handlePlugins();
            this.markdownService.highlight(this.element.nativeElement);
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        MarkdownComponent.prototype.coerceBooleanProperty = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return value != null && "" + value !== 'false';
        };
        /**
         * @private
         * @return {?}
         */
        MarkdownComponent.prototype.handleData = /**
         * @private
         * @return {?}
         */
        function () {
            this.render(this.data);
        };
        /**
         * @private
         * @return {?}
         */
        MarkdownComponent.prototype.handleSrc = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.markdownService
                .getSource(this.src)
                .subscribe((/**
             * @param {?} markdown
             * @return {?}
             */
            function (markdown) {
                _this.render(markdown);
                _this.load.emit(markdown);
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return _this.error.emit(error); }));
        };
        /**
         * @private
         * @return {?}
         */
        MarkdownComponent.prototype.handleTransclusion = /**
         * @private
         * @return {?}
         */
        function () {
            this.render(this.element.nativeElement.innerHTML, true);
        };
        /**
         * @private
         * @return {?}
         */
        MarkdownComponent.prototype.handlePlugins = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.lineHighlight) {
                this.setPluginClass(this.element.nativeElement, PrismPlugin.LineHighlight);
                this.setPluginOptions(this.element.nativeElement, { dataLine: this.line, dataLineOffset: this.lineOffset });
            }
            if (this.lineNumbers) {
                this.setPluginClass(this.element.nativeElement, PrismPlugin.LineNumbers);
                this.setPluginOptions(this.element.nativeElement, { dataStart: this.start });
            }
        };
        /**
         * @private
         * @param {?} element
         * @param {?} plugin
         * @return {?}
         */
        MarkdownComponent.prototype.setPluginClass = /**
         * @private
         * @param {?} element
         * @param {?} plugin
         * @return {?}
         */
        function (element, plugin) {
            var _a;
            /** @type {?} */
            var preElements = element.querySelectorAll('pre');
            for (var i = 0; i < preElements.length; i++) {
                /** @type {?} */
                var classes = plugin instanceof Array ? plugin : [plugin];
                (_a = preElements.item(i).classList).add.apply(_a, __spread(classes));
            }
        };
        /**
         * @private
         * @param {?} element
         * @param {?} options
         * @return {?}
         */
        MarkdownComponent.prototype.setPluginOptions = /**
         * @private
         * @param {?} element
         * @param {?} options
         * @return {?}
         */
        function (element, options) {
            var _this = this;
            /** @type {?} */
            var preElements = element.querySelectorAll('pre');
            var _loop_1 = function (i) {
                Object.keys(options).forEach((/**
                 * @param {?} option
                 * @return {?}
                 */
                function (option) {
                    /** @type {?} */
                    var attributeValue = options[option];
                    if (!!attributeValue) {
                        /** @type {?} */
                        var attributeName = _this.toLispCase(option);
                        preElements.item(i).setAttribute(attributeName, attributeValue.toString());
                    }
                }));
            };
            for (var i = 0; i < preElements.length; i++) {
                _loop_1(i);
            }
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        MarkdownComponent.prototype.toLispCase = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var upperChars = value.match(/([A-Z])/g);
            if (!upperChars) {
                return value;
            }
            /** @type {?} */
            var str = value.toString();
            for (var i = 0, n = upperChars.length; i < n; i++) {
                str = str.replace(new RegExp(upperChars[i]), '-' + upperChars[i].toLowerCase());
            }
            if (str.slice(0, 1) === '-') {
                str = str.slice(1);
            }
            return str;
        };
        MarkdownComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'markdown, [markdown]',
                        template: '<ng-content></ng-content>'
                    }] }
        ];
        /** @nocollapse */
        MarkdownComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MarkdownService }
        ]; };
        MarkdownComponent.propDecorators = {
            data: [{ type: core.Input }],
            src: [{ type: core.Input }],
            lineNumbers: [{ type: core.Input }],
            start: [{ type: core.Input }],
            lineHighlight: [{ type: core.Input }],
            line: [{ type: core.Input }],
            lineOffset: [{ type: core.Input }],
            error: [{ type: core.Output }],
            load: [{ type: core.Output }]
        };
        return MarkdownComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkdownPipe = /** @class */ (function () {
        function MarkdownPipe(elementRef, markdownService, zone) {
            this.elementRef = elementRef;
            this.markdownService = markdownService;
            this.zone = zone;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        MarkdownPipe.prototype.transform = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var _this = this;
            if (value == null) {
                return '';
            }
            if (typeof value !== 'string') {
                console.error("MarkdownPipe has been invoked with an invalid value type [" + value + "]");
                return value;
            }
            /** @type {?} */
            var markdown = this.markdownService.compile(value);
            this.zone.onStable
                .pipe(operators.first())
                .subscribe((/**
             * @return {?}
             */
            function () { return _this.markdownService.highlight(_this.elementRef.nativeElement); }));
            return markdown;
        };
        MarkdownPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'markdown',
                    },] }
        ];
        /** @nocollapse */
        MarkdownPipe.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MarkdownService },
            { type: core.NgZone }
        ]; };
        return MarkdownPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = {
        gfm: true,
        tables: true,
        breaks: false,
        pedantic: false,
        sanitize: false,
        smartLists: true,
        smartypants: false,
    };
    /** @type {?} */
    var initialMarkedOptions = {
        provide: MarkedOptions,
        useValue: ɵ0,
    };
    /** @type {?} */
    var sharedDeclarations = [
        LanguagePipe,
        MarkdownComponent,
        MarkdownPipe,
    ];
    var MarkdownModule = /** @class */ (function () {
        function MarkdownModule() {
        }
        /**
         * @param {?=} markdownModuleConfig
         * @return {?}
         */
        MarkdownModule.forRoot = /**
         * @param {?=} markdownModuleConfig
         * @return {?}
         */
        function (markdownModuleConfig) {
            return {
                ngModule: MarkdownModule,
                providers: [
                    MarkdownService,
                    markdownModuleConfig && markdownModuleConfig.loader || [],
                    markdownModuleConfig && markdownModuleConfig.markedOptions || initialMarkedOptions,
                ],
            };
        };
        /**
         * @return {?}
         */
        MarkdownModule.forChild = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: MarkdownModule,
            };
        };
        MarkdownModule.decorators = [
            { type: core.NgModule, args: [{
                        exports: sharedDeclarations,
                        declarations: sharedDeclarations,
                    },] }
        ];
        return MarkdownModule;
    }());

    exports.LanguagePipe = LanguagePipe;
    exports.MarkdownComponent = MarkdownComponent;
    exports.MarkdownModule = MarkdownModule;
    exports.MarkdownPipe = MarkdownPipe;
    exports.MarkdownService = MarkdownService;
    exports.MarkedOptions = MarkedOptions;
    exports.MarkedRenderer = MarkedRenderer;
    exports.PrismPlugin = PrismPlugin;
    exports.errorSrcWithoutHttpClient = errorSrcWithoutHttpClient;
    exports.initialMarkedOptions = initialMarkedOptions;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-markdown.umd.js.map
